package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JFrame;

import tsp.TSP;

/** Most simple JFrame for the visualization of the algorithm progress. */
public class TSPGui extends JFrame {

	/** Default serial version id. */
    private static final long serialVersionUID = 1L;
    
    /** Dimension the GUI's frame. */
	private Dimension dim = new Dimension(800,600);
	
	/** JavaView Display implementation. */
	private JvDisplay jvDisp;
	
	/** Constructor for the GUI. */
	public TSPGui(TSP tsp) {
		
		super("File: "+tsp.getFileName());
		
		this.jvDisp = new JvDisplay(tsp);
		
		this.add(jvDisp.getDisplay(),BorderLayout.CENTER);
		
		this.setSize(dim);
		
		Dimension screen = this.getToolkit().getScreenSize();
		
		this.setLocation(
				(screen.width  - dim.width ) , 50 );

		this.setVisible(true);
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	/** Returns the interal JavaView display implementation. */
	public JvDisplay getJvDisp() { return jvDisp; }
}