package lk.datastructures;

/** Implementation of a Move, that is a usual 2-opt move or a Mak-Morton move. */
public class Move implements Comparable <Move> {
	
	public double promisingCost;
	
	public int a      ;
	public int prev_a ;
	public int next_a ;
	
	public boolean makMorton;

	public Move( int a , int prev_or_next_a , double promisingCost , boolean makMorton ) 
	{
		this.a          = a ;
		if(makMorton)
		    this.next_a = prev_or_next_a ;
		else
			this.prev_a = prev_or_next_a ;
		
		this.promisingCost = promisingCost;	
		this.makMorton     = makMorton;
	}
	
	public boolean isMakMortonMove() {return makMorton     ; }
	
	public int compareTo(Move o) 
	{
		int ret = 0;
		if ( promisingCost  < o.promisingCost ) ret = -1;
		if ( promisingCost == o.promisingCost ) ret =  0;
		if ( promisingCost  > o.promisingCost ) ret =  1;
		
		return ret * -1;
	}
	
	public String toString() {
		return "move( "+("flip")+" , "+ String.format("%5.2f", promisingCost) + " )";
	}

	
}