package lk.datastructures;

public class Queue {
	
	boolean[] active ;
	Elem first = null ;
	Elem last  = null ;
	int n;
	
	public Queue(int size)
	{
		active = new boolean[size] ;
		
		this.n = size ;
		init();
	
	}
	
	public void add( int knoten )
	{
		if( ! active[knoten] ) {
			
			active[knoten] = true ;
			
			Elem elem = new Elem( knoten ) ;

			if ( isEmpty() ) 
				first    =  elem ;
			else 
				last.next = elem ;
			
			last  = elem ;
		}
	}
	
	
	public void init() 
	{
		for( int node = 0 ; node < n ; ++node )
			add(node);
	}
	
	public int pop() 
	{
		if( ! isEmpty() ) 
		{
			Elem elem = first ;
			int  node = elem .node ;
						
			first = first.next ;
			
			active[node] = false ;
			
			if( elem == last )
				last = null ;
			
			elem = null ;

			return node ;
		}
		
		return -1 ;
	}
	
	public int peek() {
		return first == null ? -1 : first.node ;
	}

	private class Elem {
			
		int  node  ;
		Elem next ;
		
		Elem(int node) {
			this.node = node ;
			this.next = null ;
		}
	}
	
	public boolean isEmpty() 
	{
		return first == null ;
	}
}
