package lk.datastructures;

import java.io.Serializable;

import tsp.Node;

public class Vertex implements Serializable {

	private int id;
	private int rank;
	
	private Vertex next ;
	private Vertex prev ;
	
	private Vertex[] neighbors ;
	
	private Node node;
	
	public Vertex( Node node ) 
	{ 
		this.id   = node.getID()   ; 
		this.node = node ;
	}
	
	public    int       id() { return id;  }
	
	public Node getNode() { return node; }

	public  Vertex    next() {return next; }
	public  Vertex    prev() {return prev; }

	public   Vertex[] getNeighbors() { return neighbors; }

	protected void setNeighbors(Vertex[] neighbors) 
	{
		this.neighbors = neighbors; 
	}

	protected void setNext(Vertex next) {
		assert this != next ;
		this.next = next;
	}

	protected void setPrev(Vertex prev) {
		assert this != prev;
		this.prev = prev;
	}

	protected int rank() {
		return rank;
	}

	protected void setRank(int rank) {
		this.rank = rank;
	}
	public String toString () { return id 
		//+ " <"+rank +">"
		+""; }
	
	private static final long serialVersionUID = 1L;
}