package main;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import tsp.Node;

/** Implemenets some static utility member functions. */
public class Util  {

	/** Rounds a to the nearest integer. */
	private static int nint(double a) {
		return (int) (a + 0.5);
	}

	/** Computes the euclidian distance for the edge {tail,head}. */
	public static int cost(Node tail, Node head) {

		return nint(Math.sqrt(Math.pow((tail.getX() - head.getX()), 2)
				+ Math.pow((tail.getY() - head.getY()), 2)));
	}

	/**
	 * Copies object by serialization.
	 * 
	 * @param ob reference to object to copy
	 * 
	 * @return returns a reference to the copy of the object
	 */
	public static Object deepCopy(Object ob) {
		Object copy = null;

		try {
			// serialize 
			ByteArrayOutputStream out = new ByteArrayOutputStream();
			ObjectOutputStream os = new ObjectOutputStream(out);
			os.writeObject(ob);
			os.flush();

			// deserialize 
			ObjectInputStream is = new ObjectInputStream(
					new ByteArrayInputStream(out.toByteArray()));
			copy = is.readObject();
			is.close();
			os.close();
		} catch (Exception e) {
			System.err.println(e + "error");
			System.exit( 1 );
		}

		return copy;
	}

	/** Prints the usage of the program to stderr and exits the main process with status '1'. */
	public static void printUsageAndExit() {
		System.err.println("usage: program input-file [sleep-time=1sec]\n");
		System.exit(1);
	}
}
