package tsp;

import main.Util;

import java.util.Iterator;
import java.util.Vector;

/** Represents a TSP tour in pure data representation, i.e., it
 * does not implement any algorithmic aspects.*/
public class Tour extends Vector<Node> {

	private static final long serialVersionUID = 1L;

	/** Default constructor. */
	public Tour() {
		super();
	}

	/** Copy constructor. */
	public Tour(Vector<Node> tour) {
		super(tour);
	}

	/** Computes the cost of the tour. */
	public double cost() {

		double cost = 0.0;

		Iterator<Node> I = iterator();

		Node prev = I.next(), next = null;

		while (I.hasNext()) {

			next = I.next();

			cost += cost(prev, prev = next);
		}
		
		cost += cost( firstElement() , lastElement() );
		
		return cost;
	}

	/** Returns the cost of edge {m1,m2}. */
	private double cost(Node m1, Node m2) {
		return Util.cost(m1, m2);
	}

	/** Adds a node to the tour and if setTour _== true it sets this as tour of node. */
	public boolean add( Node node ) {
		return super.add(node);
	}

	/** Inserts the node at the given position and increments the cost by addCost. */
	public void insertElementAt(Node node, int position ) {
		super.insertElementAt(node, position);
	}

	/** Returns the node at position i. */
	public Node at(int i) {
		return this.elementAt(i);
	}
}